//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "EPCityConq.h"
#include "citylist.h"
#include "playerlist.h"


EPCityConq::EPCityConq(unsigned int city, unsigned int player)
    :ECityConq(city), d_player(player)
{
    d_type = PCITYCONQUERED;
}

EPCityConq::EPCityConq(XML_Helper* helper)
    :ECityConq(helper)
{
    helper->getData(d_player, "player");
    d_type = PCITYCONQUERED;
}

EPCityConq::~EPCityConq()
{
}

bool EPCityConq::save(XML_Helper* helper)
{
    bool retval = true;

    retval &= helper->openTag("event");
    retval &= helper->saveData("type", std::string("EPCITYCONQUERED"));
    retval &= helper->saveData("city", d_city);
    retval &= helper->saveData("player", d_player);

    retval &= Event::save(helper);

    retval &= helper->closeTag();
    
    return retval;
}

void EPCityConq::trigger(City* city)
{
    if (!d_active)
        return;

    if ((city->getId() != d_city) || (city->getPlayer()->getId() != d_player))
        return;

    raise();
    d_active = false;
}

Player* EPCityConq::getPlayer()
{
    Playerlist* plist = Playerlist::getInstance();
    for (Playerlist::iterator it = plist->begin(); it != plist->end(); it++)
        if ((*it)->getId() == d_player)
            return (*it);

    return 0;
}
