//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "ObjectList.h"

//#define debug(x) {std::cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<endl;}
#define debug(x)

template<class T> ObjectList<T>::ObjectList()
{
}

template<class T> ObjectList<T>::~ObjectList()
{
}

template<class T> T* ObjectList<T>::getObjectAt(int x, int y) 
{
    for (typename ObjectList<T>::iterator it = begin(); it != end(); ++it)
    {
        PG_Point p = (*it).getPos();
        int size = (*it).getSize() - 1;

        if (p.x >= (x - size) && p.x <= x && p.y >= (y - size) && p.y <= y)
        {
            return &(*it);
        }
    }
    return 0;
}

template<class T> T* ObjectList<T>::getObjectAt(const PG_Point& pos) 
{
    return getObjectAt(pos.x, pos.y);
}

// End of file
