//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef OptionsDialog_H
#define OptionsDialog_H

#include <pgwindow.h>
#include <pgeventobject.h>
#include <pgcheckbutton.h>
#include <pglabel.h>

/** Dialog for game options
  *
  * Currently, this dialog has the options "smooth scrolling" and
  * "Show next player popup". If you want to add any further on-the-fly
  * configurable options, add them in this dialog.
  */

class OptionsDialog : public PG_EventObject, public PG_Window, public SigC::Object
{
    public:
        // CREATORS
        OptionsDialog(PG_Widget* parent, PG_Rect rect);
        ~OptionsDialog();

        // CALLBACK FUNCTIONS
        PARAGUI_CALLBACK(okClicked);
        PARAGUI_CALLBACK(cancelClicked);
        PARAGUI_CALLBACK(helpClicked);
        PARAGUI_CALLBACK(smoothClicked);
        PARAGUI_CALLBACK(showNextClicked);

    private:
        // WIDGETS
        PG_CheckButton* d_cb_smooth_scrolling;
        PG_CheckButton* d_cb_show_next_player;
        PG_Label* d_l_caption;
        PG_Button* d_b_ok;
        PG_Button* d_b_cancel;
        PG_Button* d_b_help;
};

#endif

// End of file
