//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include "Quest.h"
#include "QuestsManager.h"
#include "playerlist.h"
#include "stacklist.h"
#include <iostream>
using namespace std;

//#define debug(x) {cerr<<__FILE__<<": "<<__LINE__<<": "<<x<<endl;}
#define debug(x)
//=====================================================================
int Quest::questCompleted()
{
    debug("Quest has been completed.");
    debug("Congratulations " << getHeroId());
    d_q_mgr.questCompleted(getHeroId());
    return 0;
}
//=====================================================================
void Quest::deactivate()
{
    pending = 0;
}
//===========================================================================
Hero* getHeroById(int id, Stack** stack)
{
    Playerlist* list = Playerlist::getInstance();
	Playerlist::iterator pit;
    for (pit = list->begin(); pit != list->end(); pit++)
    {
        Stacklist* stacklist = (*pit)->getStacklist();
        for (Stacklist::const_iterator it = stacklist->begin(); 
            it != stacklist->end(); it++)
        {
            for (Stack::iterator sit = (*it)->begin(); 
                sit != (*it)->end(); sit++)
            {
                if ( ((*sit)->isHero()) && (((*sit)->getId()) == id) )
                {
                    if (stack)
                        *stack = (*it);
                    // isHero is TRUE, so dynamic_cast should succeed
                    return dynamic_cast<Hero*>(*sit);
                }
            }
        }
    }
    return NULL;
}
